//+------------------------------------------------------------------+

//| Wick.mq4 |

//| Seavo |

//| http://www.forexfactory.com/member.php?u=17692 |

//+------------------------------------------------------------------+

#property copyright "Seavo"
#property link "http://www.forexfactory.com/member.php?u=17692"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1 8
#property indicator_width2 8

//
//
//
//
//

extern double upperLevel       = 5.0;
extern double lowerLevel       = -5.0;
extern string note             = "turn on Alert = true; turn off = false";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = true;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = true;
extern bool   alertsEmail      = false;
extern bool   alertsNotify     = false;
extern string soundFile        = "alert2.wav";


double ExtMapBuffer1[];
double ExtMapBuffer2[];
double trend[];
int PipFactor = 1;
//+------------------------------------------------------------------+

//| Custom indicator initialization function |

//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,trend);
   SetLevelValue(0,upperLevel);
   SetLevelValue(1,lowerLevel);

   IndicatorShortName("Wick");
   
   if (Digits == 3 || Digits == 5)
   {
      PipFactor = 10;
   }

return(0);

}

//+------------------------------------------------------------------+

//| Custor indicator deinitialization function |

//+------------------------------------------------------------------+

int deinit()

{

//----

//----

return(0);

}

//+------------------------------------------------------------------+

//| Custom indicator iteration function |

//+------------------------------------------------------------------+

int start()
{

   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);   

   //
   //
   //
   //
   //
   
   for (pos=limit; pos >= 0; pos--)
   {                    
      if (iOpen(NULL, 0, pos) > iClose(NULL, 0, pos))
      {
         double dResult1 = iHigh(NULL, 0, pos) - iOpen(NULL, 0, pos);
      }
      if (iOpen(NULL, 0, pos) <= iClose(NULL, 0, pos))
      {
         dResult1 = iHigh(NULL, 0, pos) - iClose(NULL, 0, pos);
      }
      if (iOpen(NULL, 0, pos) > iClose(NULL, 0, pos))
      {
         double dResult2 = iLow(NULL, 0, pos) - iClose(NULL, 0, pos);
      }
      if (iOpen(NULL, 0, pos) <= iClose(NULL, 0, pos))
      {
         dResult2 = iLow(NULL, 0, pos) - iOpen(NULL, 0, pos);
      }

      ExtMapBuffer1[pos] = (dResult1/Point)/PipFactor ;
      ExtMapBuffer2[pos] = (dResult2/Point)/PipFactor ;
      trend[pos] = trend[pos+1];
         if (ExtMapBuffer1[pos]>upperLevel) trend[pos] =-1;
         if (ExtMapBuffer2[pos]<lowerLevel) trend[pos] = 1;

   }

   //
   //
   //
   //
   //
      
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1;
     if (trend[whichBar] != trend[whichBar+1])
     if (trend[whichBar] == 1)
           doAlert("Buy");
     else  doAlert("Sell");       
   }

return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Wick-O-Gram ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Wick-O-Gram "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," Wick-O-Gram " +" "+message));
             if (alertsSound)   PlaySound(soundFile);
      }
}
      